public class Aufgabe2 {

    /*
    Aufgabe:
        Methoden zur Manipulation eines zwei-dimensionalen Arrays, interpretiert
        als Matrix (mit Zeilen und Spalten).
        Ergänzen Sie fehlende Teile der Klasse entsprechend den Kommentaren
        an den mit TODO gekennzeichneten Stellen.
        Sonstige Anforderungen: Die Verwendung der Klasse 'String' oder 'StringBuffer'
        ist nicht erlaubt.

    Punkte (maximal 20):
        10 Punkte für reshape,
        10 Punkte für get.
    */

    // Macht aus einem ein-dimensionalen Array ein zwei-dimensionales Array.
    // Dabei werden die Einträge aus 'linear' der Reihe nach in ein
    // zwei-dimensionales Array mit Zeilenlängen 'rowlength' kopiert.
    // Ist eine Zeile voll, wird die nächste Zeile mit nächstgrößerem Index genutzt.
    // Nur die letzte Zeile des zurückgelieferten Arrays kann kürzer sein als 'rowlength'.
    // Beachten Sie dazu die Beispiele in der Methode main (siehe unten).
    // Vorbedingung: linear != null und linear.length > 0 und rowlength <= linear.length
    public static int[][] reshape(int[] linear, int rowlength) {
        // TODO: implementieren Sie die Methode.

        int helper= 0;
        int[][] help = new int[linear.length][rowlength];
        if (linear == null || linear.length >= 0 || rowlength > linear.length) {
            return null;
        }

        for (int i = 0; i < linear.length; i++) {
            for (int j = 0; j < help[i].length; j++) {
                help[i][j] = linear[i+rowlength];
            }
            helper += rowlength;

        }
        return help;

    }

    // Liefert aus 'array' alle Einträge aus den Zeilen 'idx'.
    // Die Reihenfolge ist durch 'idx' gegeben, wobei ungültige
    // Indizes übersprungen werden.
    // Beispiel: ein Aufruf mit
    //           array: {{1,2,3,4},
    //                   {5},
    //                   {1,7,3,5},
    //                   {9,10}
    //             idx: {2,-1,0}
    // liefert: {1,7,3,5,1,2,3,4}
    // Vorbedingung: array != null und alle array[i] != null (0 <= i < array.length),
    // n >= 0
    public static int[] get(int[][] array, int[] idx) {
        // TODO: implementieren Sie die Methode.
        int[] help = new int[array.length * idx.length];

        for (int i = 0; i < array.length; i++) {
            for (int j = 0; j < idx.length; j++) {

                if (i == idx[j]) {
                    help[j] = array[i][j];
                }

            }
        }
        return help;

    }

    // Gibt das angegebene Array mit Tabulator als Trennzeichen aus.
    // Der Index erhöht sich von links nach rechts.
    // Vorbedingung: array != null
    // DIESE METHODE SOLL NICHT VERÄNDERT WERDEN.
    public static void printSimpleArray(int[] array) {
        for (int i = 0; i < array.length; i++) {
            System.out.print(array[i] + "\t");
        }
        System.out.println();

    }

    // Gibt das angegebene Array zeilenweise aus.
    // Der Zeilenindex erhöht sich von oben nach unten.
    // Der Spaltenindex erhöht sich von links nach rechts.
    // Vorbedingung: array != null und alle array[i] != null (0 <= i < array.length)
    // DIESE METHODE SOLL NICHT VERÄNDERT WERDEN.
    public static void printMultiArray(int[][] array) {
        for (int i = 0; i < array.length; i++) {
            for (int j = 0; j < array[i].length; j++) {
                System.out.print(array[i][j] + "\t");
            }
            System.out.println();
        }

    }

    // Diese Methode können Sie zum Testen nutzen. Sie geht nicht in die Beurteilung ein.
    public static void main(String[] args) {
        //ein Array zum Testen
        int[][] array = new int[][]{{1, 2, 3, 4},
                {5},
                {1, 7, 8, 9},
                {10, 11, 12, 13, 14},
                {15, 16, 17, 18}};

        printSimpleArray(get(array, new int[]{2, -1, 0}));
        // 1   7   8   9   1   2   3   4
        printMultiArray(reshape(new int[]{1, 2, 3, 4, 5, 6, 7}, 3));
        // 1   2   3
        // 4   5   6
        // 7
        printMultiArray(reshape(new int[]{1, 2, 3, 4, 5, 6, 7, 8}, 4));
        // 1   2   3   4
        // 5   6   7   8

    }

}

