import org.junit.Assert;
import org.junit.Rule;
import org.junit.Test;
import org.junit.contrib.java.lang.system.StandardOutputStreamLog;
import org.junit.rules.Timeout;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertEquals;

public class Aufgabe3Test {

    @Rule
    public Timeout globalTimeout = Timeout.millis(1000);

    @Rule
    public final StandardOutputStreamLog log = new StandardOutputStreamLog();

    // liefert alle Primfaktoren von n die im Intervall i bis n liegen.
    // Vorbedingung: n > 0 und i > 0 und n >= i
    public static String factors(int n, int i) {
        String sum = "";
        while (i < n) {
            if (n%i == 0) {
                sum += i + ".";
                n/=i;
            } else {
                i++;
            }
        }
        return n%i == 0 ? sum + i : sum;
    }

    public static int f(int n) {
        return n < 0 ? f(-n+1) : n%2;
    }

    @Test
    public void testFactorsWithoutSeparator() throws Exception {
        for(int n = 2; n < 100; n++) {
            Assert.assertThat(Aufgabe3.factors(n,2).replaceAll(".",""),
                    is(Aufgabe3Test.factors(n,2).replaceAll(".","")));
        }
    }

    @Test
    public void testF0() throws Exception {
        Assert.assertThat(Aufgabe3.f(0), is(Aufgabe3Test.f(0)));
    }

    @Test
    public void testF1() throws Exception {
        Assert.assertThat(Aufgabe3.f(1), is(Aufgabe3Test.f(1)));
    }

    @Test
    public void testF4() throws Exception {
        Assert.assertThat(Aufgabe3.f(4), is(Aufgabe3Test.f(4)));
    }

    @Test
    public void testFneg1() throws Exception {
        Assert.assertThat(Aufgabe3.f(-5), is(Aufgabe3Test.f(-5)));
    }

    @Test
    public void testFactorsFull() throws Exception {
        for(int n = 2; n < 100; n++) {
            Assert.assertThat(Aufgabe3.factors(n,2), is(Aufgabe3Test.factors(n,2)));
        }
    }

    @Test
    public void testPrintSimpleArray() throws Exception {
        int[] input = new int[]{1,2,10,11,12};
        Aufgabe3.printArray(input, 1,3);
        Assert.assertEquals("2\t10\t11", log.getLog().trim());
        log.clear();
    }

    @Test
    public void testPrintSimpleArrayWithoutSeparator() throws Exception {
        int[] input = new int[]{1,2,10,11,12};
        Aufgabe3.printArray(input, 0,3);
        assertEquals("121011", log.getLog().trim().replaceAll("\\s",""));
        log.clear();
    }

    @Test
    public void testPrintSimpleArrayStart() throws Exception {
        int[] input = new int[]{1,2,10,11,12};
        Aufgabe3.printArray(input, 0,3);
        assertEquals("1\t2\t10\t11", log.getLog().trim());
        log.clear();
    }

    @Test
    public void testPrintSimpleArrayEnd() throws Exception {
        int[] input = new int[]{1,2,10,11,12};
        Aufgabe3.printArray(input, 2,4);
        assertEquals("10\t11\t12", log.getLog().trim());
        log.clear();
    }

}